
package de.ivu.elect.presentation.gebietsbaum;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.gebietsbaum.boundary.GebietsarteigenschaftConversationStore;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsarteigenschaftExtendedDAO;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsarteigenschaftEdit;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsarteigenschaft;
import de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractGebietsarteigenschaftEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractGebietsarteigenschaftEditNoScopeView.VIEW_ID, useCase = UseCasePermission.GEBIETSARTEIGENSCHAFT_EDIT)
public abstract class AbstractGebietsarteigenschaftEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Gebietsarteigenschaft>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsarteigenschaftEditView";

  public static final String VIEW_ID = "/gebietsbaum/gebietsarteigenschaft-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/gebietsbaum/gebietsarteigenschaft-search.xhtml";

  @Inject
  protected transient GebietsarteigenschaftExtendedDAO extendedDAO;

  @Inject
  protected transient GebietsarteigenschaftEdit edit;

  @Inject
  @ConversationGroup(GebietsarteigenschaftConversationStore.class)
  protected transient GebietsarteigenschaftConversationStore conversationStore;

  @Inject
  protected transient GebietsarteigenschaftMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient GebietsarteigenschaftEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Gebietsarteigenschaft getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Gebietsarteigenschaft entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GEBIETSARTEIGENSCHAFT_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Gebietsarteigenschaft entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.GEBIETSARTEIGENSCHAFT_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.GEBIETSARTEIGENSCHAFT_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GEBIETSARTEIGENSCHAFT_EDIT)
  @Override
  public String save() {
    Gebietsarteigenschaft entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Gebietsarteigenschaft entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Gebietsarteigenschaft entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Gebietsarteigenschaft entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.GEBIETSARTEIGENSCHAFT_EDIT);
  }
  
  @Redirect
  public String edit(Gebietsarteigenschaft entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class GebietsarteigenschaftEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Gebietsarteigenschaft,   de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftPK  > {

    private static final long serialVersionUID = 1L;
  }
}
